/*
    Copyright 2005-2008 EPOS-Project
                        (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
                        Arnold Krille <arnold@arnoldarts.de>

    This library is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation; version 3 of the License.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; see the files lgpl-3.0.txt and
    gpl-3.0.txt. If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef FILTEREXPRESSION_H
#define FILTEREXPRESSION_H

#include "mathexpression.h"

namespace NSEvaluation {

class FilterExpression : public NSCore::MathExpression
{
	public:
		FilterExpression( NSCore::QTreeItem* );

		QString debug() const { return QString( "FilterExpression(%1)" ).arg( true ); }

		double value( NSCore::AcqisitionDataSet& data );

		QString toXML() const { return ""; }

		QVariant guiValue() const { return filter; }
		void guiSetValue( QVariant n );

		Qt::ItemFlags guiFlags() const;

		QStringList guiActions() const {
			return QStringList() << "Add Expression";
		}

		void guiExecAction( QString action, NSCore::GuiServer_Interface* gui );

		void addChild( NSCore::MathExpression* pexp, NSCore::GuiServer_Interface* gui );

		void deleteMe( NSCore::MathExpression* exp, NSCore::GuiServer_Interface* gui );

		void workOnCache();

	protected:
		void timerEvent( QTimerEvent* );

	private:
		bool filter;
		QList< QPair<QString,NSCore::MathExpression*> > _childsToAdd;
		QList<NSCore::MathExpression*> _childsToDelete;
};

};
#endif // FILTEREXPRESSION_H
