/*
    Copyright 2005-2008 EPOS-Project
                        (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
                        Arnold Krille <arnold@arnoldarts.de>

    This library is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation; version 3 of the License.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; see the files lgpl-3.0.txt and
    gpl-3.0.txt. If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef SPLINEDEBUG_H
#define SPLINEDEBUG_H

#include "plugins_interface.h"

#include "interpolation_helpers.h"

class CFSplineDebugAnalyzer : public NSEvaluation::Analyzer, private Spline
{
	public:
		CFSplineDebugAnalyzer( NSCore::QTreeItem* );
		~CFSplineDebugAnalyzer();

		QString type() const { return "CFSplineDebugAnalyzer"; }

		void analyze( NSCore::AcqisitionDataSet& data );

	private:
		double y( int );
		NSEvaluation::Analyzer* _minimumanalyzer;
};

class SplineDebug_Client : public NSEvaluation::PluginFactory_Client {
	public:
		SplineDebug_Client() { }
		virtual ~SplineDebug_Client() { }

		NSEvaluation::Plugin* create( QString s, NSCore::QTreeItem* p ) {
			if ( s == "CFSplineDebugAnalyzer" )
				return new CFSplineDebugAnalyzer( p );
			return 0;
		}

		QStringList canCreate() {
			return QStringList()
								 << "CFSplineDebugAnalyzer"
								 ;
		}

		QString type( QString plugin ) {
			if ( canCreate().contains( plugin ) ) {
				return "Analyzer";
			}
			return "";
		}
};

#endif // SPLINEDEBUG_H

